#ifndef __ADC_H__
#define __ADC_H__

#define ADCKS_2DIV 			ADCFG |= 0x00
#define ADCKS_4DIV 			ADCFG |= 0x01
#define ADCKS_8DIV 			ADCFG |= 0x02
#define ADCKS_16DIV 		ADCFG |= 0x03

#define AD_VREF_VDD 		ADCFG |= 0 << 6
#define AD_VREF_36  		ADCFG |= 1 << 6
#define AD_VREF_24  		ADCFG |= 2 << 6
#define AD_VREF_20  		ADCFG |= 3 << 6

#define AD_CONT_enable 		ADCFG |= SET_BIT4
#define AD_CONT_disable 	ADCFG &= CLR_BIT4
#define AD_INT_MODE				ADCFG |= SET_BIT2
#define AD_EN							ADCON |= SET_BIT3
#define AD_DIS						ADCON &= CLR_BIT3
#define AD_TRIG						ADCON |= SET_BIT0

extern void Delay_1ms(unsigned int Del_1ms);
unsigned int get_adc_val(uint8_t channel,uint8_t times);
void ADC_Init(void);
void PWM_init_ADC(void);
void ADC_Test(void);

#endif