#include <ATM8F8040K.H>
#include "main.h"
#include "wakeup.h"

#define wakeup_mode0		//WDT
//#define wakeup_mode1		//WT
//#define wakeup_mode2		//int0,int1ʾ
//#define wakeup_mode3		//int2,int3ʾ

/*Źλʱ
WDT_TIME 	= Twdtclk * (wdttime+1) * 4096
						= (wdttime+1) * 0.128s
wdttime :0 ~ 63
*/
void WDT_Init( uint8_t wdttime)
{
	WDT_CLKEN; 	//wdtʱʹ
	WDTCON = wdttime << 2; 
	WDT_EN;
	//
	WDT_RLD();
}
void WDT_RLD(void)
{	
	//
	 WDTRLD = 0x5A;
	 WDTRLD = 0x3C;
}

#ifdef wakeup_mode0

/*Źʱ
WDT_TIME 	= Twdtclk * (wdtwk*4+3) 
TwdtclkΪ32KHZʱ
ŹѼ10λ,2λ̶ֵΪ11
WDTWKΪ0xFF,ʵΪ1111 1111 11,1023,WDTWKΪ0xF0,ʵΪ1111 0000 11963
wdttime :0 ~ 255
*/
void WDTWK_Init( uint8_t wdttimer)
{
	WDT_CLKEN;  //wdtʱʹ
	WDTWK = wdttimer;
	IT0 = 1;
	EINT0 |= 0xC0; 	//ѡP20жԴΪWDTƥź,ش
	IE_INT0_WDT_enable;    //ʹWDTж
	EA = 1; 	
	WDTCON |= 0xFC;	//WDTTIMEΪֵ,ֹѺλ
	WDT_EN;
	WDT_RLD();
//STOPǰҪ֤ⲿжϱ־λIE0/1/2/3δΪ0STOPģʽILRC
}
void WAKEUP_Test(void)
{
	WDTWK_Init(255);
	P0CR |= SET_BIT2;
	while(1)
	{
		PCON_STOP;
		P0_2 = ~P0_2;
	}
}
void EINT0_INT(void)	interrupt 0
{
	WDT_RLD();
}
#endif

#ifdef wakeup_mode1
/*Ѷʱʱ
WT_TIME 	= Twtclk * (wttime+1) * 16384
						= (wdttime+1) * 0.5s
wdttime :0 ~ 63
*/
void WT_Init(uint8_t wttime)
{
	WT_CLKEN;  //wtʱʹ	
	WTCON  = wttime << 2;
	IT1 = 1;
	EINT1 |= 0xC0; 	//ѡP21жԴΪWTƥź,ش
	IE_INT1_WT_enable;    //ʹWTѶʱж
	EA = 1;
	WT_EN;
//STOPǰҪȷⲿжϱ־λIE0/1/2/3Ϊ0STOPģʽILRC
//STOPģʽǰȷWTCLRΪ0޷STOPģʽ
}
void WAKEUP_Test(void)
{
	WT_Init(0);
	P0CR |= SET_BIT2;
	while(1)
	{
		PCON_STOP;
		P0_2 = ~P0_2;
	}
}
void EINT1_INT(void)	interrupt 2
{
	
}
#endif

#ifdef wakeup_mode2
/*ⲿжԴ1*/
void INT1_Init(void)		//P21ΪͨIO
{
	P2CR &= CLR_BIT1;
	P2PCR &= CLR_BIT1;	
	P2SELL &= 0xF3;
	IT1 = 1;
	EINT1 |= 0x40; 	//ѡP21ΪⲿжԴش
	IE_INT1_WT_enable;     //ʹINT1ж
	EA = 1;
}
void WAKEUP_Test(void)
{
	INT1_Init();
	P0CR |= SET_BIT2;
	while(1)
	{
		PCON_STOP;
		P0_2 = ~P0_2;
	}
}
void EINT1_INT(void)	interrupt 2
{
	
}
#endif

#ifdef wakeup_mode3
/*ⲿжԴ2*/
void INT2_Init(uint8_t IT2src)		//ʹʱӦ˿
{
	EINT0 |= IT2src << 2; 	//ѡP00~07ΪⲿжԴ
	EINT0 |= 0x01; 	//½زж	
	IE_INT2_enable;    //ʹINT2ж
	EA = 1;
}
void WAKEUP_Test(void)
{
	INT2_Init(7);
	P0CR |= SET_BIT2;
	while(1)
	{
		PCON_STOP;
		P0_2 = ~P0_2;
	}
}
void EINT2_INT(void)	interrupt 12
{
	
}
#endif

